#include <stdio.h>
#include "xmp.h"

void sub(double a[2][2],double b[2][2], double c[2][2],int m,int l,int n)
{
#pragma xmp nodes p(2)
#pragma xmp template t(0:1)
#pragma xmp distribute t(block) onto p
#pragma xmp align a[*][i] with t(i)
#pragma xmp align b[i][*] with t(i)
int i,j,k;
#pragma xmp loop on t(k) reduction(+:c)
       for (k=0; k<n; k++)
          for(j=0; j<m; j++)
           for(i=0; i<l; i++)
             c[i][j] = c[i][j]+a[i][k]*b[k][j];
if(xmp_node_num()==1){
printf("%lf\n",c[0][0]);
printf("%lf\n",c[0][1]);
printf("%lf\n",c[1][0]);
printf("%lf\n",c[1][1]);
}
}
int main(){
#pragma xmp nodes p(2)
#pragma xmp template t(0:1)
#pragma xmp distribute t(block) onto p
double a[2][2],b[2][2],c[2][2];
#pragma xmp align a[*][i] with t(i)
#pragma xmp align b[i][*] with t(i)


if(xmp_node_num()==1)
a[0][0]=1.0;
if(xmp_node_num()==2)
a[0][1]=2.0;
if(xmp_node_num()==1)
a[1][0]=3.0;
if(xmp_node_num()==2)
a[1][1]=4.0;

if(xmp_node_num()==1)
b[0][0]=1.0;
if(xmp_node_num()==1)
b[0][1]=2.0;
if(xmp_node_num()==2)
b[1][0]=3.0;
if(xmp_node_num()==2)
b[1][1]=4.0;

c[0][0]=0.0;
c[0][1]=0.0;
c[1][0]=0.0;
c[1][1]=0.0;
sub(a,b,c,2,2,2);
return 0;
}
